/***********************************************************************\
*                                unl2d.d                                *
*                                                                       *
*                         Unlambda to D compiler                        *
*                                                                       *
*                              Version 0.1                              *
*                                                                       *
*                            Main entry point                           *
>***********************************************************************<
* Copyright (C) 2006-2007 Stewart Gordon.                               *
*                                                                       *
* This software is provided 'as-is', without any express or implied     *
* warranty.  In no event will the author be held liable for any damages *
* arising from the use of this software.                                *
*                                                                       *
* Permission is granted to anyone to use this software for any purpose, *
* including commercial applications, and to alter it and redistribute   *
* it freely, subject to the following restrictions:                     *
*                                                                       *
* - The origin of this software must not be misrepresented; you must    *
*   not claim that you wrote the original software.  If you use this    *
*   software in a product, an acknowledgment in the product             *
*   documentation would be appreciated but is not required.             *
* - Altered source versions must be plainly marked as such, and must    *
*   not be misrepresented as being the original software.               *
* - This notice may not be removed or altered from any source           *
*   distribution.                                                       *
*                                                                       *
* Email me with comments/suggestions/bug reports: smjg@iname.com        *
\***********************************************************************/
module smjg.prog.unlambda.ul2d;
import
	smjg.prog.unlambda.translate,
	std.path,
	std.file,
	std.cstream,
	std.string,
	std.stream,
	std.stdio;

int main(char[][] args) {
	if (args.length != 2) {
		return help();
	}

	char[] code = cast(char[]) read(defaultExt(args[1], "unl"));
	code = replace(code, \r\n, \n);
	code = replace(code, \r, \n);

	char[] mainDCode = parse(code);

	char[] outputName = addExt(args[1], "d");
	scope File outputFile = new File(outputName, FileMode.OutNew);

	outputFile.writefln("import smjg.prog.unlambda.runtime;\n");
	outputFile.writefln("void main() {");
	writeCharsNeeded(outputFile);

	outputFile.writefln("\tcast(void) %s;", mainDCode);
	outputFile.writefln("}");

	return 0;
}


int help() {
	writefln("unl2d: Unlambda to D compiler
Copyright 2006 Stewart Gordon
Usage: unl2d filename");
	return 113;
}
